(function ($) {

    /**
     * @function
     * @property {object} jQuery plugin which runs handler function once specified element is inserted into the DOM
     * @param {function} handler A function to execute at the time when the element is inserted
     * @param {bool} shouldRunHandlerOnce Optional: if true, handler is unbound after its first invocation
     * @example $(selector).waitUntilExists(function);
     */

    $.fn.waitUntilExists    = function (handler, shouldRunHandlerOnce, isChild) {
        var found       = 'found';
        var $this       = jQuery(this.selector);
        var $elements   = $this.not(function () { return $(this).data(found); }).each(handler).data(found, true);

        if (!isChild)
        {
            (window.waitUntilExists_Intervals = window.waitUntilExists_Intervals || {})[this.selector] =
                window.setInterval(function () { $this.waitUntilExists(handler, shouldRunHandlerOnce, true); }, 500)
            ;
        }
        else if (shouldRunHandlerOnce && $elements.length)
        {
            window.clearInterval(window.waitUntilExists_Intervals[this.selector]);
        }

        return $this;
    }

}(jQuery));

jQuery('#content_picpoll_plugin').waitUntilExists(function(){

    jQuery('#content_picpoll_plugin').dropdown('attach', '#dropdown-1');

});

jQuery(document).ready(function(){

   if(jQuery("#the_main_editor").length)
   {
       jQuery('#main_editor_vs_picpoll_plugin').waitUntilExists(function(){

           jQuery('#main_editor_vs_picpoll_plugin').dropdown('attach', '#dropdown-1');

       });
   }
   jQuery('.nds_insert').click(function(){
       tinyMCE.activeEditor.execCommand('mceInsertContent', false, "[nds_poll id='"+jQuery(this).attr('id')+"']");

   })
});