(function() {

    tinymce.create('tinymce.plugins.nds_pic_buttons', {
        /**
         * Initializes the plugin, this will be executed after the plugin has been created.
         * This call is done before the editor instance has finished it's initialization so use the onInit event
         * of the editor instance to intercept that event.
         *
         * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
         * @param {string} url Absolute URL to where the plugin is located.
         */
        init : function(ed, url) {
            ed.addButton('picpoll_plugin', {
                title : 'Add PicPoll',
                cmd : 'picpoll_plugin',
                image : url + '/../images/tasks.png',
                oninit: function() {

                },
                onclick : function(v) {

                    }

            });


        },

        /**
         * Creates control instances based in the incomming name. This method is normally not
         * needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
         * but you sometimes need to create more complex controls like listboxes, split buttons etc then this
         * method can be used to create those.
         *
         * @param {String} n Name of the control to create.
         * @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
         * @return {tinymce.ui.Control} New control instance or null if no control was created.
         */
       /* createControl : function(n, cm) {
            switch (n) {
                case 'picpoll_plugin':
                    var mlb = cm.createListBox('nds_pic_buttons', {
                        title : 'Insert PicPoll',
                        onselect : function(v) {
                            tinyMCE.activeEditor.windowManager.alert('Value selected:' + v);
                        }
                    });
                   // alert (ajaxUrl);
                    // Add some values to the list box
                    mlb.add('Some item 1', 'val1');
                    mlb.add('some item 2', 'val2');
                    mlb.add('some item 3', 'val3');

                    // Return the new listbox instance
                    return mlb;
            }

            return null;

        },*/

        /**
         * Returns information about the plugin as a name/value array.
         * The current keys are longname, author, authorurl, infourl and version.
         *
         * @return {Object} Name/value array containing information about the plugin.
         */
        getInfo : function() {
            return {
                longname : 'PicPoll Custom Buttons',
                author : 'Sorin NUnca',
                authorurl : 'http://sorinnunca.com',
                infourl : 'http://sorinnunca.com',
                version : "0.1"
            };
        }
    });

    // Register plugin
    tinymce.PluginManager.add( 'nds_pic_buttons', tinymce.plugins.nds_pic_buttons );


})();

jQuery(document).load(function(){


});