<?php
    /*  Plugin Name: WP PicPoll
        Description: WP-PicPoll is an easy to use,  high quality,  wordpress plugin which creates amazing polls/quizzes utilizing the Power of Pictures.
        Author: HQ Info Group
        Author URI: http://WP-PicPoll.com
        Version: 1.4
    */

    include "libraries/wpFramework.php";
    include "ndsVote.php";
    include "templatefunk.php";

    define("NAME", "WP PicPoll");
    define("SLUG", "nds_polls_plugin");

    class pollsPlugin extends wpFramework
    {
        public function __construct()
        {
            parent::__construct(dirname(__FILE__));



            add_action("admin_menu", array($this, "admin_menu"));

            add_action("wp_enqueue_scripts", array($this, "load_styles"));
            add_action( 'admin_enqueue_scripts', array($this, 'load_post_scripts'), 10, 1 );



            register_activation_hook(__FILE__, array($this, "activation_hook"));



            add_action("init", array($this, "custom_button"));


            add_action("admin_footer", array($this, "render_hidden_meta"));
        }

        /*public function add_meta_box()
        {
            add_meta_box( 'poll_hidden_meta', 'Poll Choice Meta', array($this, "render_hidden_meta") , 'post', 'normal', 'high' );
            add_meta_box( 'poll_hidden_meta', 'Poll Choice Meta', array($this, "render_hidden_meta") , 'page', 'normal', 'high' );
        }*/

        public function render_hidden_meta()
        {
            global $wpdb;
            $polls = $wpdb->get_results("SELECT * from ".$this->tablename, "ARRAY_A");

            $data = '<div id="dropdown-1" class="dropdown dropdown-tip" style="display:none;">
                <ul class="dropdown-menu">';
            if(count($polls)>0)
                foreach($polls as $poll)
                {
                    $data.= "<li><a href='#' class='nds_insert' id='{$poll['id']}'>{$poll['name']} </a>";
                }
            else
            {
                $data.="<li><a href='#'> Please add a PicPoll first</a></li>";
            }
            $data.='</ul>
            </div>';
            echo $data;

        }
        public function custom_button()
        {
            // New mce plugin and button
            add_filter( "mce_external_plugins", array($this, "add_buttons") );
            add_filter( 'mce_buttons', array($this, 'register_buttons') );

        }


        public function add_buttons($plugin_array)
        {
            $plugin_array['nds_pic_buttons'] = $this->url . 'js/custom_buttons.js';
            return $plugin_array;
        }

        public function register_buttons( $buttons)
        {
            array_push( $buttons, 'picpoll_plugin' );

            return $buttons;
        }


        public function activation_hook()
        {
            global $wpdb;
            $tablename = $this->tablename;
            $query = "CREATE TABLE `" . $tablename . "` (
            `id` mediumint(9) NOT NULL AUTO_INCREMENT,
            `name` varchar(60) NOT NULL,
            `title` varchar(360) DEFAULT '' NULL,
            `header_font` varchar(360) DEFAULT '' NULL,
            `header_font_size` varchar(360) DEFAULT '' NULL,
            `header_color` varchar(360) DEFAULT '' NULL,
            `header_background_color` varchar(360) DEFAULT '' NULL,
            `voting_system` varchar(2) DEFAULT '' NULL,
            `images` text NOT NULL,
            PRIMARY KEY  (`id`)
            );";

            $stats_table=$tablename."_stats";

            $query2 = "CREATE TABLE `" . $stats_table . "` (
            `id` mediumint(9) NOT NULL AUTO_INCREMENT,
            `poll_id` mediumint(60) NOT NULL,
            `choice` varchar(760) DEFAULT '' NULL,
            `time` varchar(20) DEFAULT '' NULL,
            `ip` varchar(30) DEFAULT '' NULL,
            PRIMARY KEY  (`id`)
            );";

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($query);

            dbDelta($query2);
        }


        public function admin_menu()
        {

            $page=add_menu_page(NAME, NAME, "manage_options", SLUG, '', 'https://cdn1.iconfinder.com/data/icons/Siena/16/poll%20yellow.png' );

            add_submenu_page(SLUG, "Dashboard", "Dashboard", "manage_options", SLUG, array($this, "admin_page"));


           // $page2=add_submenu_page(SLUG, "Add new", "Add new", "manage_options", "nds_poll_add", array($this, "add_new_html"));

            add_action("admin_print_styles-{$page}", array($this, "load_admin_styles"));
        }

        public function add_new_html()
        {
            $data['posted']=0;
            if($_POST)
            {
                global $wpdb;
                $data=$_POST;

                $wpdb->insert($this->tablename, $data);

                $data['posted']=1;

            }
            echo $this->view("add_new_html", $data);
        }





        public function admin_page()
        {
            if($_GET['pid'])
            {
                $data['posted']=0;
                global $wpdb;
                if($_POST['delete'])
                {
                    foreach($_POST['delete_id'] as $id)
                    {
                        $wpdb->query("DELETE FROM ".$this->tablename." WHERE id='{$id}'");
                    }
                }
                if($_POST['update_poll'])
                {

                    unset($_POST['update_poll']);
                    $image_name=$_POST['image_name'];
                    $image_url=$_POST['image_url'];
                    $image_link=$_POST['image_link'];
                    unset($_POST['image_name']);
                    unset($_POST['image_url']);
                    unset($_POST['image_link']);

                    foreach($image_name as $k=>$v)
                    {
                        $_POST['images'][$k]['name']=$v;
                        $_POST['images'][$k]['url']=$image_url[$k];
                        $_POST['images'][$k]['link']=$image_link[$k];
                    }
                    $_POST['images']=serialize($_POST['images']);



                    global $wpdb;
                    $where['id']=$_GET['pid'];
                    $data=$_POST;


                    $wpdb->update($this->tablename, $data, $where);

                    $data['posted']=1;
                }
                $data['polls']=$wpdb->get_results("SELECT * from ".$this->tablename, "ARRAY_A");
                echo $this->view("poll_template_add", $data);
            }
            else
            {

                $data['posted']=0;
                global $wpdb;
                if($_POST['delete'])
                {
                    foreach($_POST['delete_id'] as $id)
                    {
                        $wpdb->query("DELETE FROM ".$this->tablename." WHERE id='{$id}'");
                    }
                }
                if($_POST['add_new_poll'])
                {

                    unset($_POST['add_new_poll']);
                    $image_name=$_POST['image_name'];
                    $image_url=$_POST['image_url'];
                    $image_link=$_POST['image_link'];
                    unset($_POST['image_name']);
                    unset($_POST['image_url']);
                    unset($_POST['image_link']);

                    foreach($image_name as $k=>$v)
                    {
                        $_POST['images'][$k]['name']=$v;
                        $_POST['images'][$k]['url']=$image_url[$k];
                        $_POST['images'][$k]['link']=$image_link[$k];
                    }
                    $_POST['images']=serialize($_POST['images']);


                    global $wpdb;
                    $data=$_POST;

                    $wpdb->insert($this->tablename, $data);

                    $data['posted']=1;
                }
                $data['polls']=$wpdb->get_results("SELECT * from ".$this->tablename, "ARRAY_A");
                echo $this->view("poll_template", $data);
            }

        }

        public function load_admin_styles()
        {
            global $wp_version;
            wp_enqueue_media();
            wp_enqueue_script('media-upload');
            wp_enqueue_script('thickbox');
            wp_enqueue_style('thickbox');

            if ( 3.5 <= $wp_version )
            {
                //Both the necessary css and javascript have been registered already by WordPress, so all we have to do is load them with their handle.
                wp_enqueue_style( 'wp-color-picker' );
                wp_enqueue_script( 'wp-color-picker' );
            }
            //If the WordPress version is less than 3.5 load the older farbtasic color picker.
            else
            {
                //As with wp-color-picker the necessary css and javascript have been registered already by WordPress, so all we have to do is load them with their handle.
                wp_enqueue_style( 'farbtastic' );
                wp_enqueue_script( 'farbtastic' );
            }

            wp_register_style("nds_poll_admin", $this->url.'css/admin.css');
            wp_enqueue_style("nds_poll_admin");

            $js_array=array();
            $js_array['nds_poll_admin']='admin.js';
            foreach($js_array as $key=>$value)
            {
                wp_register_script($key, $this->url."js/".$value, array('jquery'));
                wp_enqueue_script($key);
            }
        }
        public function load_styles()
        {
            wp_register_style("nds_poll_css", $this->url.'css/main.css');
            wp_enqueue_style("nds_poll_css");

            $js_array=array();
            $js_array['nds_poll_main']='main.js';
            foreach($js_array as $key=>$value)
            {
                wp_register_script($key, $this->url."js/".$value, array('jquery'));
                wp_enqueue_script($key);
                if($value=='main.js')
                {
                    $data['ajaxUrl']=admin_url('admin-ajax.php');
                    wp_localize_script("nds_poll_main","nds_poll_main", $data);
                }
            }
        }

        public  function load_post_scripts($hook)
        {

            if( $hook == 'post-new.php' || $hook == 'post.php' || $hook =='post-new.php?post_type=pic_poll' )
            {
                wp_register_style("nds_dropdown", $this->url.'css/jquery.dropdown.css');
                wp_enqueue_style("nds_dropdown");

                wp_register_script("nds_dropdown", $this->url.'js/jquery.dropdown.js');
                wp_enqueue_script("nds_dropdown");

                wp_register_script("nds_post", $this->url.'js/admin_post.js');
                wp_enqueue_script("nds_post");


            }
        }

    }

    include "plugin-update-checker.php";
     $MyUpdateChecker = new PluginUpdateChecker(
        'http://wp-gomo.com/upd8/updater.json',
        __FILE__,
        'wppicpol'
    );


    $ndsVote = new ndsVote();
    $pollsPlugin =  new pollsPlugin();

