<?php

$plugin_url = trailingslashit( WP_PLUGIN_URL.'/'.dirname( plugin_basename(__FILE__) ));



// Register Custom Post Type
function custom_post_type() {

    $labels = array(
        'name'                => _x( 'Pic Polls', 'Post Type General Name', 'pic_poll' ),
        'singular_name'       => _x( 'Pic Poll', 'Post Type Singular Name', 'pic_poll' ),
        'menu_name'           => __( 'Pic Poll', 'pic_poll' ),
        'parent_item_colon'   => __( 'Parent Pic Poll:', 'pic_poll' ),
        'all_items'           => __( 'All Pic Polls', 'pic_poll' ),
        'view_item'           => __( 'View Pic Poll', 'pic_poll' ),
        'add_new_item'        => __( 'Add New Pic Poll', 'pic_poll' ),
        'add_new'             => __( 'New Pic Poll', 'pic_poll' ),
        'edit_item'           => __( 'Edit Pic Poll', 'pic_poll' ),
        'update_item'         => __( 'Update Pic Poll', 'pic_poll' ),
        'search_items'        => __( 'Search Pic Pollls', 'pic_poll' ),
        'not_found'           => __( 'No Pic Polls Found', 'pic_poll' ),
        'not_found_in_trash'  => __( 'No Pic Polls Found in Trash', 'pic_poll' ),
    );
    $args = array(
        'label'               => __( 'Pic_Poll', 'pic_poll' ),
        'description'         => __( 'To Create Pic Polls', 'pic_poll' ),
        'labels'              => $labels,
        'supports'            => array( 'title', ),
        'hierarchical'        => false,
        'public'              => true,
        'show_ui'             => true,
        'show_in_menu'        => true,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'menu_icon'           => 'https://cdn1.iconfinder.com/data/icons/Futurosoft%20Icons%200.5.2/16x16/mimetypes/template_source.png',
        'can_export'          => true,
        'has_archive'         => true,
        'exclude_from_search' => false,
        'publicly_queryable'  => true,
        'capability_type'     => 'page',
    );
    register_post_type( 'Pic_Poll', $args );

}

// Hook into the 'init' action
add_action( 'init', 'custom_post_type', 0 );






// ********** END OF CUSTOM POST TYPE***************

    define('THEMEROOT', get_stylesheet_directory_uri());



    // Add the Meta Box
    function add_custom_meta_box() {

         add_meta_box(
            'the_main_editor', // $id
            ' The Main Editor', // $title 
            'the_main_editor_preview', // $callback
            'Pic_Poll', // $page
            'normal', // $context
            'high'); // $priority 

            $page = "Pic_Poll";
            $id = 'facebook_links';
          add_meta_box(
            'facebook_links', // $id
            'Facebook Links', // $title 
            'load_links', // $callback
            'Pic_Poll', // $page
            'normal', // $context
            'high'); // $priority 

           add_filter( "postbox_classes_{$page}_{$id}", 'force_open' );

        add_meta_box(
            'custom_meta_box', // $id
            'Set the Background Image', // $title 
            'show_custom_meta_box', // $callback
            'Pic_Poll', // $page
            'normal');


        
    }



    add_action('add_meta_boxes', 'add_custom_meta_box');

    function force_open($classes)
    {
        var_dump($classes);
        unset($classes['closed']);

        return $classes;
    }

// ***************************** END OF  META BOXES *******************************   

    // Field Array
    $prefix = 'custom_';
    $custom_meta_fields = array(
        
        array(
            'label' => 'Image',
            'desc'  => 'Please Upload a Large Image e.g. 1900 px X 1200 px',
            'id'    => $prefix.'image',
            'type'  => 'image'
        )
    );

    // enqueue scripts and styles, but only if is_admin
    if(is_admin()) {
        wp_enqueue_script('jquery-ui-datepicker');
        wp_enqueue_script('jquery-ui-slider');
        wp_enqueue_script('custom-js', $plugin_url.'/js/custom-js.js');
        wp_enqueue_style('jquery-ui-custom', get_template_directory_uri().'/css/jquery-ui-custom.css');
    }

    // add some custom js to the head of the page
    add_action('admin_head','add_custom_scripts');
    function add_custom_scripts() {
        global $custom_meta_fields, $post;
        
        $output = '<script type="text/javascript">
                    jQuery(function() {';
        
        foreach ($custom_meta_fields as $field) { // loop through the fields looking for certain types
            // date
            if($field['type'] == 'date')
                $output .= 'jQuery(".datepicker").datepicker();';
            // slider
            if ($field['type'] == 'slider') {
                $value = get_post_meta($post->ID, $field['id'], true);
                if ($value == '') $value = $field['min'];
                $output .= '
                        jQuery( "#'.$field['id'].'-slider" ).slider({
                            value: '.$value.',
                            min: '.$field['min'].',
                            max: '.$field['max'].',
                            step: '.$field['step'].',
                            slide: function( event, ui ) {
                                jQuery( "#'.$field['id'].'" ).val( ui.value );
                            }
                        });';
            }
        }
        
        $output .= '});
            </script>';
            
        echo $output;
    }
    function load_links()
    {
        global $post, $custom_meta_fields;

        $base_url = get_permalink($post);

        $base_secure = str_replace("http://", "https://", $base_url);

        $free_ssl = "https://poll-free-ssl.herokuapp.com/?url=";


        $domain = get_option('siteurl'); //or home
        $domain = str_replace('http://', '', $domain);
        $domain = str_replace('www', '', $domain); //add the . after the www if you don't want it
        $our_url = strstr($domain, '/', true); //PHP5 only, this is in case WP is not root

        echo "<h1>Your Own SSL </h1> 
        Choose this if your server has SSL <br/>
        <table>
         <tr>
            <td>App Domain : </td> <td><input type='text' style='width:500px' name='canvas_url' value='{$our_url}' /> </td>
        </tr>
        <tr>
            <td>Canvas URL : </td> <td><input type='text' style='width:500px' name='canvas_url' value='{$base_url}' /> </td>
        </tr>
        <tr>
            <td>Secure Canvas URL:</td><td> <input type='text' style='width:500px' name='secure_canvas_url' value='{$base_secure}' /> </td>
        </tr> </table>
        ";

        echo "<h1>Our free SSL</h1>
        Choose this if you want to use our free SSL service <br/>
         <table>
       <tr>
            <td>App Domain : </td> <td><input type='text' style='width:500px' name='canvas_url' value='poll-free-ssl.herokuapp.com' /> </td>
        </tr>
        <tr>
            <td>Canvas URL : </td> <td><input type='text' style='width:500px' name='canvas_url' value='{$base_url}' /> </td>
        </tr>
        <tr>
            <td>Secure Canvas URL:</td><td> <input type='text' style='width:500px' name='secure_canvas_url' value='{$free_ssl}{$base_url}' /> </td>
        </tr> </table>

        ";
        
    }
    // The Callback
    function show_custom_meta_box() {
        global $custom_meta_fields, $post;
        // Use nonce for verification
        echo '<input type="hidden" name="custom_meta_box_nonce" value="'.wp_create_nonce(basename(__FILE__)).'" />';
        
        // Begin the field table and loop
        echo '<table class="form-table">';
        foreach ($custom_meta_fields as $field) {
            // get value of this field if it exists for this post
            $meta = get_post_meta($post->ID, $field['id'], true);
            // begin a table row with
            echo '<tr>
                    <th><label for="'.$field['id'].'">'.$field['label'].'</label></th>
                    <td>';
                    switch($field['type']) {
                        
                        case 'image':
                            $image = plugins_url( '/images/image.png' , __FILE__ );  
                            echo '<span class="custom_default_image" style="display:none">'.$image.'</span>';
                            if ($meta) { $image = wp_get_attachment_image_src($meta, 'medium'); $image = $image[0]; }               
                            echo    '<input name="'.$field['id'].'" type="hidden" class="custom_upload_image" value="'.$meta.'" />
                                        <img src="'.$image.'" class="custom_preview_image" alt="" /><br />
                                            <input class="custom_upload_image_button button" type="button" value="Choose Image" />
                                            <small>&nbsp;<a href="#" class="custom_clear_image_button">Remove Image</a></small>
                                            <br clear="all" /><span class="description">'.$field['desc'].'</span>';
                        break;
                        
                    } //end switch
            echo '</td></tr>';
        } // end foreach
        echo '</table>'; // end table
        //echo $image;
    }

    

    // Save the Data
    function save_custom_meta($post_id) {
        global $custom_meta_fields;
        
        // verify nonce
        if (!wp_verify_nonce($_POST['custom_meta_box_nonce'], basename(__FILE__))) 
            return $post_id;
        // check autosave
        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
            return $post_id;
        // check permissions
        if ('page' == $_POST['post_type']) {
            if (!current_user_can('edit_page', $post_id))
                return $post_id;
            } elseif (!current_user_can('edit_post', $post_id)) {
                return $post_id;
        }
        
        // loop through fields and save the data
        foreach ($custom_meta_fields as $field) {
            if($field['type'] == 'tax_select') continue;
            $old = get_post_meta($post_id, $field['id'], true);
            $new = $_POST[$field['id']];
            if ($new && $new != $old) {
                update_post_meta($post_id, $field['id'], $new);
            } elseif ('' == $new && $old) {
                delete_post_meta($post_id, $field['id'], $old);
            }
        } // enf foreach
        
        // save taxonomies
        $post = get_post($post_id);
        $category = $_POST['category'];
        wp_set_object_terms( $post_id, $category, 'category' );
    }
    add_action('save_post', 'save_custom_meta');



    // We are Adding WP Meta Editor

    function the_main_editor_preview($post){
        $content_main = get_post_meta($post->ID);
        $contents_main = isset( $content_main['main_editor_vs'] ) ?  $content_main['main_editor_vs'][0] : 
        '
            <h1>Lorem ipsum dolor sit amet, consectetur adipisicing elit amet, consectetur adipisicing elit.</h1>
             <h2>Lorem ipsum dolor sit amet, consectetur adipisicing elit.</h2>
             
             <ul>
                 <li>Consectetur adipisicing elit amet</li>
                 <li>Consectetur adipisicing elit amet</li>
                 <li>Consectetur adipisicing elit amet</li>
                 <li>Consectetur adipisicing elit amet</li>
              </ul> 
        '; 
        wp_editor( $content = $contents_main , $editor_id = 'main_editor_vs', $settings = array() );
    }



    add_action( 'save_post', 'vs_main_editor_box_save' );
        
            function vs_main_editor_box_save( $post_id )
                {
                    // Bail if we're doing an auto save
                    if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

                    
                    // if our current user can't edit this post, bail
                    if( !current_user_can( 'edit_post' ) ) return;
                    
                    // Probably a good idea to make sure your data is set
                    if( isset( $_POST['main_editor_vs'] ) )
                        update_post_meta( $post_id, 'main_editor_vs', $_POST['main_editor_vs'] );


                }






// The Redirect Function 

    function theme_redirect() {
            global $wp;
            $plugindir = dirname( __FILE__ );
        
            //A Specific Custom Post Type
            if ($wp->query_vars["post_type"] == 'pic_poll') {
                $templatefilename = 'templates/index.php';
                if (file_exists(TEMPLATEPATH . '/' . $templatefilename)) {
                    $return_template = TEMPLATEPATH . '/' . $templatefilename;
                } else {
                    $return_template = $plugindir . '/' . $templatefilename;
                }
                
                do_theme_redirect($return_template);
        
            }
            
        }

        function do_theme_redirect($url) {
            global $post, $wpdb, $wp_query;
            if (have_posts()) {
                
                include($url);
                die();

            } else {
                $wp_query->is_404 = true;
            }
        }
        

        function get_page_post($type = '') {
            global $wpdb, $table_prefix;
            $sql = "SELECT * FROM `{$table_prefix}posts` WHERE `post_status` = 'publish' AND `post_type` = '{$type}'";
            $result = $wpdb->get_results($sql);
            return $result;
        }

        add_action("template_redirect", 'theme_redirect');